<?php

namespace Drupal\graphviz_filter\Plugin;

use Drupal\Core\Plugin\DefaultPluginManager;
use Drupal\Core\Cache\CacheBackendInterface;
use Drupal\Core\Extension\ModuleHandlerInterface;

/**
 * Provides the Format plugin manager.
 *
 * @package Drupal\graphviz_filter\Plugin
 */
class FilterFormatPluginManager extends DefaultPluginManager {

  /**
   * FormatManager constructor.
   *
   * @param \Traversable $namespaces
   *   An object that implements \Traversable which contains the root paths
   *   keyed by the corresponding namespace to look for plugin implementations.
   * @param \Drupal\Core\Cache\CacheBackendInterface $cache_backend
   *   Cache backend instance to use.
   * @param \Drupal\Core\Extension\ModuleHandlerInterface $module_handler
   *   The module handler to invoke the alter hook with.
   */
  public function __construct(\Traversable $namespaces, CacheBackendInterface $cache_backend, ModuleHandlerInterface $module_handler) {
    parent::__construct(
      'Plugin/FilterFormat',
      $namespaces,
      $module_handler,
      'Drupal\graphviz_filter\Plugin\FilterFormatInterface',
      'Drupal\graphviz_filter\Annotation\FilterFormat');

    $this->alterInfo('graphviz_filter_filter_format_info');
    $this->setCacheBackend($cache_backend, 'graphviz_filter_filter_format_plugins');
  }
}
